EvaluateScript("managers.js")
EvaluateScript("scrollie_main.js")
EvaluateScript("items.js")
EvaluateScript("replay.js")

font = LoadFont("font.rfn")
window = LoadWindowStyle("window.rws")

Platforms = new Array()
Mouse = new oMouse()

var K_JUMP1 = KEY_W
var K_JUMP2 = KEY_SPACE
var K_LEFT = KEY_A
var K_RIGHT = KEY_D
var K_PLATRESET = KEY_T

function KeySet()
{	
	gSound.pause()
	
	var kc = -1
	var key = new Array()

	while (1)
		{
			switch (kc)
				{
					case 0:
						font.drawText(0,0,"Press Jump 1 key")
					break; case 1:
						font.drawText(0,0,"Press Jump 2 key")
					break; case 2:
						font.drawText(0,0,"Press Move Left key")
					break; case 3:
						font.drawText(0,0,"Press Move Right key")
					break; case 4:
						font.drawText(0,0,"Press Platform Reset key")
					break; case 5:
						gSound.play(true)
						K_JUMP1 = key[0]
						K_JUMP2 = key[1]
						K_LEFT = key[2]
						K_RIGHT = key[3]
						K_PLATRESET = key[4]
						return 
					break;
				}
			
			FlipScreen()	
				
			if (AreKeysLeft()) kc++
				
			while ( AreKeysLeft() )
				{
					key[kc-1] = GetKey()
				}
		}	

}

var gClickTime = 0
var gSlowMode = false
var gSlowVar = 0

var gPirateMushroomMode = false
var gPirateCount = 0

const NORMAL_PLATFORM = 0
const LEFTRIGHT_PLATFORM = 1
const UPDOWN_PLATFORM = 2
const FALL_PLATFORM = 3
const BOUNCE_PLATFORM = 4

var LR_TIME = 100;
var UD_TIME = 100;

function game()
{
	//UProcList.push( gReplay.RecordUpdate )
	//UProcList.push( gReplay.ReplayUpdate )
	UProcList.push( ProcessPeople )
	UProcList.push( MouseInput )
	UProcList.push( ProcPlatforms ) 
	UProcList.push( ProcScrolling )
	
	//RProcList.push( RenderDebug )
	RProcList.push( RenderPlatforms )
	RProcList.push( RenderInterface )
	RProcList.push( RenderMouse )
	
	
	GameInitilization()
	
  CreatePerson("aegis", "aegis.rss", true);
  AttachCamera("aegis");
  
  People.push ( new oPerson( "aegis", onPlayerTouch, PlayerUpdate) )	
	
	TitleScreen()
	
	MapEngine("intro-1.rmp", 60);
	
	
	
	//RProcList.push( DebugRender )
	
}

function TitleScreen(def)
{
	gUpdateFrame = 0;
	Mouse.lives = 3

	PlaySng("2hrintro.xm")
	
	RProcList.pop()
	
	UProcList.unshift( gReplay.ReplayUpdate )
	
	RProcList.push( TitleScreenRender )
	UProcList.push( TitleScreenUpdate )
	
	if (def != undefined) 
		{
			gWarp = "intro-1.rmp"
			UProcList.push( DoWarp ) 		
		}
  
}

function RemItem(Arr, Item)
{
	for (var i = 0; i < Arr.length; i++)
		{
			if (Arr[i] == Item) Arr.splice(i,1)
		}
}

function BeginGame()
{
	gDead = false;

	gIntroImagesN = -1
	gIntroImagesOn = false;

  gScrollTime = 0
  gScrollX = 0
  gScrollY = 0
  gScrollSpeed = 0

	UProcList.pop()
	RProcList.pop()
	
	Mouse.lives = 3
	
	RemItem(UProcList, gReplay.ReplayUpdate)
	
	gReplayOn = false;
	
	RProcList.push(RenderMouse)
	
	PlaySng("2hrlevel.xm")
	
	gWarp = "level1-1.rmp"
	UProcList.push( DoWarp )
}

function onPlayerTouch(obs)
{
	obs.onTouch(this)
}

function RenderDebug()
{
	font.drawText(0,0,People[0].yv)
	font.drawText(0,10,People[0].xv)
	font.drawText(0,20, gMLeft)
	font.drawText(0,30, gScrollTime) 
	font.drawText(0,40, gSoundList.length) 
}

var gImageList = {}
function GetImage(filename) {
  if (!(filename in gImageList)) {
    gImageList[filename] = LoadImage(filename);    
  }
  return gImageList[filename];
}

var gWidthList = {}
function GetWidth(person) {
  if (!(person in gWidthList)) {
    gWidthList[person] = GetPersonWidth(person)    
  }
  return gWidthList[person];
}

var gHeightList = {}
function GetHeight(person) {
  if (!(person in gHeightList)) {
    gHeightList[person] = GetPersonHeight(person)    
  }
  return gHeightList[person];
}

function DoNothing() { }

function Random(lo,hi)
{
	hi++
	var random = lo += Math.floor(Math.random() * (hi - lo));
	return random
}

gSound = LoadSound("2hrintro.xm")

function PlaySng(song)
{
	gSound.stop()
	gSound = LoadSound(song)
	gSound.play(true);
}

var gIntroImagesN = -1
var gIntroImagesT = 0
var gIntroImagesOn = false

function TitleScreenRender()
{
	var imgs = ["intro1.png","intro2.png","intro3.png","intro4.png","intro5.png","intro6.png"]

	if (ReadWorldCheck(4)) font.drawText(40,80, "PRESS 2/3/4 to world-warp!")
	else
		{
			if (ReadWorldCheck(3)) font.drawText(40,80, "PRESS 2/3 to world-warp!")
			else
				{
					if (ReadWorldCheck(2)) font.drawText(40,80, "PRESS 2 to world-warp!")
				}
		}
	
	

	

	bg = GetImage("title.png")
	font.setColorMask(CreateColor(255,255,255))
	//while (1)
	//	{
			bg.blit(0,0)
			if (Math.sin(GetTime()>>8) > 0)
				{
					font.drawText(100,220,"Press Enter")
				}
			//FlipScreen()

	//	}
	
	if (gIntroImagesOn)
		{
			if (gIntroImagesT < GetTime()-5000) 
				{
					gIntroImagesT = GetTime()
					gIntroImagesN++;
					if (gIntroImagesN > imgs.length-1) 
						{ 					
							gIntroImagesN = -1
							gIntroImagesOn = false; 
							
							UProcList.push(gReplay.ReplayUpdate)
							
							gKeyUp = false;
							gKeyLeft = false
							gKeyRight = false
							
							gMLeft = false
							gMRight = false	
							
							SwapMap( "intro-1.rmp" )
							gUpdateFrame = 2									
						}
				}
			if (gIntroImagesN >= 0 ) GetImage(imgs[gIntroImagesN]).blit(0,0)
		}	
	
	font.setColorMask(CreateColor(255,255,255))	
}

function TitleScreenUpdate()
{
			if (IsKeyPressed(KEY_ENTER)) { BeginGame() }
			if (IsKeyPressed(KEY_ESCAPE)) { Exit(); }
			if (IsKeyPressed(KEY_P)) { gPirateCount++; }
			if (IsKeyPressed(KEY_2) && ReadWorldCheck(2) ) StrtLvl("level2-1.rmp")
			if (IsKeyPressed(KEY_3) && ReadWorldCheck(3) ) StrtLvl("level3-1.rmp")
			if (IsKeyPressed(KEY_4) && ReadWorldCheck(4) ) StrtLvl("level4-0.rmp")
			//if (IsKeyPressed(KEY_0) ) StrtLvl("level4-7.rmp")
			if (IsKeyPressed(KEY_F2)) KeySet()
				
			
			if (gPirateCount > 10) gPirateMushroomMode = true;
}

function StrtLvl(lvl)
{
					gDead = false;

					gIntroImagesN = -1
					gIntroImagesOn = false;
					
					gScrollTime = 0
					gScrollX = 0
					gScrollY = 0
					gScrollSpeed = 0
					
					UProcList.pop()
					RProcList.pop()
						
					Mouse.lives = 3
						
					RemItem(UProcList, gReplay.ReplayUpdate)
						
					gReplayOn = false;
						
					RProcList.push(RenderMouse)
						
					PlaySng("2hrlevel.xm")
						
					gWarp = lvl
					UProcList.push( DoWarp )		
}

function LevelTextDisplay(world, level)
{
	bg = GetImage("black.png")
	var c = 0
	font.setColorMask(CreateColor(255,255,255))
	
	var time = GetTime()
	
	while (time > GetTime()-1800 )
		{
			bg.blit(0,0)
			//if (Math.sin(GetTime()>>2) > 0) c++;
			//if (c > 65) break;
			//	{
					font.drawText(130,90,"World "+world)
					font.drawText(130,100,"Level "+level)
					
					
					GetImage("life.png").blit(130,120)
					font.drawText(146,120,"x"+Mouse.lives)
			//	}
			FlipScreen()

		}
	font.setColorMask(CreateColor(255,255,255))	
}

function LevelTextDisplayHint(world, level, hint)
{
	bg = GetImage("black.png")
	var c = 0
	font.setColorMask(CreateColor(255,255,255))
	
	var time = GetTime()
	
	while (time > GetTime()-2400 )
		{
			bg.blit(0,0)
			//if (Math.sin(GetTime()>>2) > 0) c++;
			//if (c > 65) break;
			//	{
					font.drawText(130,90,"World "+world)
					font.drawText(130,100,"Level "+level)
					
					font.drawTextBox(30,140,300,200, 0, hint)
					
					
					GetImage("life.png").blit(130,120)
					font.drawText(146,120,"x"+Mouse.lives)
			//	}
			FlipScreen()

		}
	font.setColorMask(CreateColor(255,255,255))	
}

function HintDisplay()
{
	var bg = GetImage("gameover.png")
	
	/*hint_imgs = 
		[
		
		]*/
	
	var hints = 
		[
			"Build platforms while jumping move faster!- Game slow down for you!",
			"Press right mouse button to cancel a build!",
			"Use the 2/3/4 keys on title screen to start at world! (Only work if you been before)",
			"Press T to destroy all platforms you built!",
			"Be sure look for secret levels!"
		]
	
	var hint = hints[Random(0,hints.length-1)]
	
	var c = 0
	
	var time = GetTime()
	
	font.setColorMask(CreateColor(255,255,255))
	while (time > GetTime()-3000)
		{
			bg.blit(0,0)
			if (Math.sin(GetTime()>>2) > 0) c++;
			if (c > 175) break;
			//	{
					font.drawTextBox(30,170,200,200, 0,hint)
					//font.drawText(130,100,"Level "+level)
					
					//font.drawText(130,120,"Lx"+Mouse.lives)
			//	}
			FlipScreen()

		}
	font.setColorMask(CreateColor(255,255,255))	
}

var gScrollTime = 0
var gScrollX = 0
var gScrollY = 0
var gScrollSpeed = 0

var gCameraX = 0
var gCameraY = 0

function ProcScrolling()
{

	if (gScrollX != 0 || gScrollY != 0)
		{

			if (gSlowMode == true)
				{
					if (gSlowVar < 12) 
						{
							gSlowVar++
							return;
						}
					else { gSlowVar = 0 }
				}	
		
			/*if (IsCameraAttached() )*/ DetachCamera()
		
			if (gScrollTime < gScrollSpeed) { gScrollTime++;  }
			else
				{
					SetCameraX( GetCameraX() + gScrollX )
					SetCameraY( GetCameraY() + gScrollY )
				
					gScrollTime = 0
				}
				
			var p = GetPlayer()	
				
			if (gScrollY < 0)
				if (GetPersonY(p.name)-150 > GetCameraY()) Die() 
				
			if (gScrollY > 0)
				if (GetPersonY(p.name)+150 < GetCameraY()) Die() 				
				
			if (gScrollX > 0)
				if (GetPersonX(p.name)+180 < GetCameraX()) Die() 
				
			if (gScrollX < 0)
				if (GetPersonX(p.name)-180 > GetCameraX()) Die() 								
		}
	else
		{
			AttachCamera("aegis")
		}

}

function endingZoomStar1(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var r = 0

	while (time > GetTime()-2000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += .2
				}
			//img2 = img.toImage()
			GetImage("flash.png").zoomBlit( -r*10, - r*15,r)
			FlipScreen()
		}

	scrn.blit(0,0)	
	GetImage("flash.png").zoomBlit( -r*10, - r*15,r)
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function endingZoomStar2(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var r = 0

	while (time > GetTime()-2000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += .2
				}
			//img2 = img.toImage()
			GetImage("flash.png").zoomBlit( r, r,r)
			FlipScreen()
		}

	scrn.blit(0,0)	
	GetImage("flash.png").zoomBlit( r, r,r)
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function endingZoomStar3(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var arr_x = new Array()
	var arr_y = new Array()
	
	for (var i = 0; i < 85; i++)
		arr_x[i] = Random(0,320)
		
	for (var i = 0; i < 85; i++)
		arr_y[i] = Random(0,240)		
	
	var r = 0

	while (time > GetTime()-2000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += .09
				}
			//img2 = img.toImage()
			for (var i = 0; i < arr_x.length; i++)
				GetImage("statue.png").rotateBlit( arr_x[i], arr_y[i],r)
			FlipScreen()
		}

	scrn.blit(0,0)	
	for (var i = 0; i < arr_x.length; i++)
		GetImage("statue.png").rotateBlit( arr_x[i], arr_y[i],r)
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function endingZoomStar4(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var r = 0

	while (time > GetTime()-2000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += .2
				}
			//img2 = img.toImage()
			GetImage("flash.png").zoomBlit( -r*10, r,r)
			FlipScreen()
		}

	scrn.blit(0,0)	
	GetImage("flash.png").zoomBlit( -r*10, r,r)
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function endingZoomStar5(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var arr_x = new Array()
	var arr_y = new Array()
	var arr_dir = new Array()
	
	for (var i = 0; i < 85; i++)
		arr_x[i] = Random(0,320)
		
	for (var i = 0; i < 85; i++)
		arr_y[i] = Random(0,240)		
		
	for (var i = 0; i < 85; i++)
		arr_dir[i] = Random(0,3)
	
	var r = 0

	while (time > GetTime()-2000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					for (var i = 0; i < arr_x.length; i++)
						switch (arr_dir[i])
							{
								case 0:
									arr_x[i]+=Random(1,3);
								break; case 1:
									arr_x[i]-=Random(1,3);
								break; case 2:
									arr_y[i]+=Random(1,3);
								break; case 3:
									arr_y[i]-=Random(1,3);
								break;
							}
						r += .09
				}
			//img2 = img.toImage()
			for (var i = 0; i < arr_x.length; i++)
				GetImage("spike.png").rotateBlit( arr_x[i], arr_y[i],r)
			FlipScreen()
		}

	scrn.blit(0,0)	
	for (var i = 0; i < arr_x.length; i++)
		GetImage("spike.png").rotateBlit( arr_x[i], arr_y[i],r)
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function endingZoomStar6(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var r = 0

	while (time > GetTime()-2000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += .2
				}
			//img2 = img.toImage()
			GetImage("flash.png").zoomBlit( r, -r*10,r)
			FlipScreen()
		}

	scrn.blit(0,0)	
	GetImage("flash.png").zoomBlit( r, -r*10,r)
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function endingZoomStar7(scrn)
{
	var time = GetTime()
	var time2 = GetTime()
	
	var arr_x = new Array()
	var arr_y = new Array()
	var arr_dir = new Array()
	var arr_color = new Array()
	var arr_xv = new Array()
	var arr_yv = new Array()

	
	for (var i = 0; i < 40; i++)
		arr_x[i] = Random(0,320)
		
	for (var i = 0; i < 40; i++)
		arr_y[i] = Random(0,240)		
		
	for (var i = 0; i < 40; i++)
		arr_dir[i] = Random(0,3)
		
	for (var i = 0; i < 40; i++)
		arr_color[i] = CreateColor( Random(0,255) , Random(0,255), Random(0,255) )		

	for (var i = 0; i < 40; i++)
		arr_xv[i] = Random(-3,3)
		
	for (var i = 0; i < 40; i++)
		arr_yv[i] = Random(-3,3)		
	
	var r = 0

	img = new Array()

	img[0] = GetImage("sparkle.png")
	img[1] = GetImage("sparkle2.png")
	img[2] = GetImage("sparkle3.png")
	img[3] = GetImage("sparkle4.png")

	while (time > GetTime()-8000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.1) 
				{
					time2 = GetTime()
					for (var i = 0; i < arr_x.length; i++)
						{
							arr_x[i]+=arr_xv[i]
							arr_y[i]+=arr_yv[i]
							
							if (arr_xv <= 0) arr_xv+=.1
							if (arr_xv >= 0) arr_xv-=.1
							if (arr_yv <= 0) arr_yv+=.1
							if (arr_yv >= 0) arr_yv-=.1
							
							if (arr_x[i] > 310) arr_xv[i] = -Random(2,3)
							if (arr_x[i] < 0) arr_xv[i] = Random(2,3)
							
							if (arr_y[i] > 220) arr_yv[i] = -Random(2,3)
							if (arr_y[i] < 0) arr_yv[i] = Random(2,3)							
						}

				}
			//img2 = img.toImage()
			for (var i = 0; i < arr_x.length; i++)
				//Point(arr_x[i], arr_y[i], arr_color[i])
				img[arr_dir[i]].blitMask(arr_x[i], arr_y[i], arr_color[i])
			FlipScreen()
		}

	scrn.blit(0,0)	
	for (var i = 0; i < arr_x.length; i++)
		//Point(arr_x[i], arr_y[i], arr_color[i])
		img[arr_dir[i]].blitMask(arr_x[i], arr_y[i], arr_color[i])
	
	scrn = GrabSurface(0, 0, 320, 240)	
	
	FlipScreen()
		
	return scrn
}

function DoEnding()
{
	PlaySng("2hrcredits.xm")

	var scrn = GrabSurface(0, 0, 320, 240)
	var img = LoadSurface("flash.png")

	var time = GetTime()
	var time2 = GetTime()
	
	var r = 0

	scrn = endingZoomStar2(scrn)

	time = GetTime()
	
	r = 0

	while (time > GetTime()-1200)
		{
			scrn.blit(0,0)		
				
			/*if (Math.sin(GetTime()>>9) > 0)*/ font.drawText(40,240/2, "You have saved fair maiden!")
			
			//GetImage("title.png").blit(0,240-r)
			
			FlipScreen()
		}
	
	scrn = endingZoomStar1( LoadImage("end1.png") )
	
	time = GetTime()
	
	r = 0

	while (time > GetTime()-8000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += 1
				}			
				
			//font.drawText(0,240-r, "Zero's Impossible Fortress")
			
			GetImage("title.png").blit(0,240-r)
			
			FlipScreen()
		}
		
	scrn = endingZoomStar3( LoadImage("end2.png") )
		
	time = GetTime()
	
	r = 0		
		
	while (time > GetTime()-8000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += 1
				}			
				
			font.drawText(110,240-r, "PRODUCED BY")
				
			font.drawText(140,275-r, "Team")
			
			GetImage("funk.png").blit(0,240-r)
			
			FlipScreen()
		}		
		
	scrn = endingZoomStar4( LoadImage("end3.png") )	
		
	time = GetTime()
	
	r = 0

	while (time > GetTime()-10000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += 1
				}			
				
			font.drawText(60,240-r, "Programming, Maps, ")
			font.drawText(60,250-r, "and Design")
			font.drawText(80,270-r, "SDHawk")
			
			font.drawText(60,290-r, "Music")
			font.drawText(80,305-r, "Troupe")
			
			font.drawText(60,325-r, "Graphics")
			font.drawText(80,345-r, "Salamando")		
			
			FlipScreen()
		}		
		
	scrn = endingZoomStar5( LoadImage("end4.png") )	
		
	time = GetTime()
	
	r = 0

	while (time > GetTime()-11500)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += 1
				}				
		
			font.drawText(60,240-r, "Beta Testing / Comments")
			font.drawText(80,260-r, "LinkMasterSab")
			font.drawText(80,275-r, "WIP")
			font.drawText(80,290-r, "Wild-Tiger")
			font.drawText(80,315-r, "and the rest of #sphere")
			font.drawText(80,340-r, "Uncommon")
			font.drawText(80,355-r, "Sew")
			font.drawText(80,370-r, "ChaosNyte")
			font.drawText(80,385-r, "Hachi-Roku")			
			
			
			FlipScreen()
		}
		
	scrn = endingZoomStar6( LoadImage("end5.png") )	
		
	time = GetTime()
	
	r = 0

	while (time > GetTime()-7400)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += 1
				}				
			
			font.drawText(60,240-r, "Special Thanks")
			font.drawText(80,255-r, "AegisKnight")
			font.drawText(80,270-r, "Flikky")
			font.drawText(80,285-r, "WIP (Pirate Mushroom Art)")
			
			FlipScreen()
		}
		
	time = GetTime()
	
	r = 0		
		
	while (time > GetTime()-6200)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					r += 1
				}				
			
			font.drawText(80,240-r, "Made with Sphere")		
			
			FlipScreen()
		}				
		
	scrn = endingZoomStar7( LoadImage("end6.png") )
		
	time = GetTime()
	time3 = GetTime()
	
	r = 0
	r2 = 0

	while (time > GetTime()-20000)
		{
			scrn.blit(0,0)
			
			if (time2 < GetTime()-.2) 
				{
					time2 = GetTime()
					if (r < 120) r += 1

				}				
	
			if (time3 < GetTime()-35) 
				{
					time3 = GetTime()
					if (r2 < 255) r2+=1;
					gSound.setVolume( 255 - r2 )				
				}	
			
			font.drawText(120,240-r, "THE FINALLY")		
			
			FlipScreen()
		}
		
	time = GetTime()
	
	r = 0		

	Exit();
}

function WriteWorldCheck(world, avail)
{
	f = OpenFile("wrld.dat")
	
	f.write("chk"+world, avail)
	
	f.flush()
}

function ReadWorldCheck(world)
{
	f = OpenFile("wrld.dat")
	
	return f.read("chk"+world, false)
}

function Snd(name,file)
{
	this.file = file
	this.name = name
}

var gSoundList = []
function GetSound(filename) 
{
	for (var i = 0; i < gSoundList.length; i++)
		{
			if (gSoundList[i].name == filename) return gSoundList[i].file;
		}
	
	gSoundList.push( new Snd(filename, LoadSound(filename) ) )
	
	return gSoundList[i].file;
}

function PlaySnd(snd)
{
	GetSound(snd).play(false);
}